'use strict';Object.defineProperty(exports,'__esModule',{value:true});var crypto=require('crypto'),fs=require('fs'),path=require('path'),events=require('events');var l=class extends Error{code;details;constructor(e,t,r){super(e),this.name="DatabaseError",this.code=t,this.details=r;}},d=class extends l{constructor(e,t){super(e,"COLLECTION_ERROR",t),this.name="CollectionError";}},p=class extends l{constructor(e,t){super(e,"DOCUMENT_ERROR",t),this.name="DocumentError";}},O=class extends l{constructor(e,t){super(e,"SCHEMA_ERROR",t),this.name="SchemaError";}},h=class extends l{constructor(e,t){super(e,"ENCRYPTION_ERROR",t),this.name="EncryptionError";}},m=class extends l{constructor(e,t){super(e,"STORAGE_ERROR",t),this.name="StorageError";}};var y=class{key;algorithm;constructor(e,t="aes-256-cbc"){this.algorithm=t,this.key=this.deriveKey(e);}deriveKey(e,t){let r=t?Buffer.from(t,"hex"):crypto.randomBytes(16);return crypto.pbkdf2Sync(e,r,1e5,32,"sha256")}encrypt(e){try{let t=crypto.randomBytes(16),r=crypto.createCipheriv(this.algorithm,this.key,t),s=r.update(e,"utf8","hex");return s+=r.final("hex"),t.toString("hex")+":"+s}catch(t){throw new h(`Encryption failed: ${t instanceof Error?t.message:"Unknown error"}`)}}decrypt(e){try{let t=e.split(":");if(t.length!==2)throw new h("Invalid encrypted data format");let r=t[0],s=t[1];if(!r||!s)throw new h("Invalid encrypted data format");let n=Buffer.from(r,"hex"),i=crypto.createDecipheriv(this.algorithm,this.key,n),o=i.update(s,"hex","utf8");return o+=i.final("utf8"),o}catch(t){throw new h(`Decryption failed: ${t instanceof Error?t.message:"Unknown error"}`)}}encryptObject(e){let t=JSON.stringify(e);return this.encrypt(t)}decryptObject(e){let t=this.decrypt(e);return JSON.parse(t)}};var g=class{name;storage;encryptionManager;schema;options;cache=new Map;indexes=new Map;isInitialized=false;documentCount=0;constructor(e,t,r={}){this.name=e,this.storage=t,this.options={autoIndex:true,maxDocuments:1e6,...r},r.schema&&(this.schema=r.schema),r.encrypt&&(this.encryptionManager=new y("default-encryption-key"));}async initialize(){if(!this.isInitialized)try{let e=await this.storage.readAllDocuments(this.name);this.options.autoIndex&&this.schema&&await this.buildIndexes(e),this.options.maxCacheSize&&this.options.maxCacheSize>0&&e.sort((r,s)=>s._updatedAt.getTime()-r._updatedAt.getTime()).slice(0,this.options.maxCacheSize).forEach(r=>{this.cache.set(r._id,r);}),this.isInitialized=!0;}catch(e){throw new d(`Failed to initialize collection: ${e instanceof Error?e.message:"Unknown error"}`)}}async ensureInitialized(){this.isInitialized||await this.initialize();}async getAllDocuments(){if(await this.ensureInitialized(),this.cache.size>0&&this.cache.size===this.documentCount)return Array.from(this.cache.values());try{let e=await this.storage.readAllDocuments(this.name),t=[],r=1e3;for(let s=0;s<e.length;s+=r){let n=e.slice(s,s+r);for(let i of n){let o=i;this.encryptionManager&&i.data&&(o=this.encryptionManager.decryptObject(i.data)),t.push(o),this.cache.set(i._id,o);}}return this.documentCount=e.length,t}catch(e){throw new d(`Failed to get documents: ${e instanceof Error?e.message:"Unknown error"}`)}}async buildIndexes(e){if(this.schema){for(let[t,r]of Object.entries(this.schema))if(r.index){let s=new Map;for(let n of e){let i=n,o=n[t];s.has(o)||s.set(o,[]),s.get(o).push(i._id);}this.indexes.set(t,s);}}}async updateIndexes(e,t){if(this.schema){for(let[r,s]of Object.entries(this.schema))if(s.index&&this.indexes.has(r)){let n=this.indexes.get(r),i=e[r];if(t==="delete"){let c=(n.get(i)||[]).filter(u=>u!==e._id);c.length===0?n.delete(i):n.set(i,c);}else {n.has(i)||n.set(i,[]);let o=n.get(i);o.includes(e._id)||o.push(e._id);}}}}extractIndexKey(e,t){let r=Object.keys(t);if(r.length===1){let s=r[0];if(s)return e[s]}return r.map(s=>e[s])}clearCache(){this.cache.clear();}async stats(){await this.ensureInitialized();let e=await this.getAllDocuments(),t=e.reduce((r,s)=>r+JSON.stringify(s).length,0);return {totalDocuments:e.length,totalSize:t,indexes:this.indexes.size,cacheSize:this.cache.size}}};function P(a,e){for(let[t,r]of Object.entries(e)){let s=a[t];if(r.required&&s==null)throw new O(`Required field '${t}' is missing`);if(s!=null&&!z(s,r.type))throw new O(`Field '${t}' has invalid type. Expected ${r.type}, got ${typeof s}`)}}function z(a,e){switch(e){case "string":return typeof a=="string";case "number":return typeof a=="number"&&!isNaN(a);case "boolean":return typeof a=="boolean";case "object":return typeof a=="object"&&!Array.isArray(a)&&a!==null;case "array":return Array.isArray(a);case "date":return a instanceof Date||typeof a=="string"&&!isNaN(Date.parse(a));default:return  false}}function M(a,e){let t={...a};for(let[r,s]of Object.entries(e))t[r]===void 0&&s.default!==void 0&&(t[r]=s.default);return t}function I(a){let{_id:e,_createdAt:t,_updatedAt:r,...s}=a;return s}function F(){return crypto.randomBytes(16).toString("hex")}function C(){return new Date}function v(a){let e=C();return {id:a||F(),createdAt:e,updatedAt:e}}var T=class{filter={};options={};collection;constructor(e){this.collection=e;}where(e,t,r){return t==="$eq"?this.filter[e]=r:this.filter[e]={[t]:r},this}and(e,t,r){return this.filter.$and||(this.filter.$and=[]),this.filter.$and.push({[e]:{[t]:r}}),this}or(e,t,r){return this.filter.$or||(this.filter.$or=[]),this.filter.$or.push({[e]:{[t]:r}}),this}sort(e,t){return this.options.sort={[e]:t},this}limit(e){return this.options.limit=e,this}skip(e){return this.options.skip=e,this}select(e){let t={};return e.forEach(r=>{t[r]=1;}),this.options.projection=t,this}async execute(){return this.collection.find(this.filter,this.options)}async findOne(){return this.options.limit=1,(await this.collection.find(this.filter,this.options)).documents[0]||null}async count(){return (await this.collection.find(this.filter,{})).total}async exists(){return await this.findOne()!==null}async findOneAndUpdate(e){let t=await this.findOne();return t&&(await this.collection.update({_id:t._id},e)).success?await this.findOne():null}async findOneAndDelete(){let e=await this.findOne();return e&&(await this.collection.delete({_id:e._id})).success?e:null}};var w=class extends g{async find(e={},t={}){await this.ensureInitialized();try{let r=await this.getAllDocuments();if(this.indexes.size>0){let c=this.useIndexes(r,e);c.length<r.length&&(r=c);}let s=t.limit||Number.MAX_SAFE_INTEGER,n=t.skip||0,i=this.filterDocuments(r,e,s+n),o=i.length;return t.sort&&i.length>1&&(i=this.sortDocuments(i,t.sort)),t.projection&&(i=this.projectDocuments(i,t.projection)),n>0&&(i=i.slice(n)),s<Number.MAX_SAFE_INTEGER&&(i=i.slice(0,s)),{documents:i,total:o,hasMore:o>n+i.length}}catch(r){throw new d(`Find failed: ${r instanceof Error?r.message:"Unknown error"}`)}}async findOne(e={}){return (await this.find(e,{limit:1})).documents[0]||null}async findById(e){if(await this.ensureInitialized(),this.cache.has(e))return this.cache.get(e);try{let t=await this.storage.readDocument(this.name,e);if(t){let r=t;return this.encryptionManager&&t.data&&(r=this.encryptionManager.decryptObject(t.data)),this.cache.set(e,r),r}return null}catch(t){throw new d(`FindById failed: ${t instanceof Error?t.message:"Unknown error"}`)}}query(){return new T(this)}async count(e={}){return (await this.find(e)).total}async isEmpty(){return await this.count()===0}filterDocuments(e,t,r){let s=[],n=Object.entries(t);for(let i of e){if(s.length>=r)break;this.matchesFilter(i,n)&&s.push(i);}return s}matchesFilter(e,t){for(let[r,s]of t)if(r.startsWith("$")){if(!this.matchesLogicalOperator(e,r,s))return  false}else {let n=e[r];if(typeof s=="object"&&s!==null){if(!this.matchesComparisonOperators(n,s))return  false}else if(n!==s)return  false}return  true}matchesLogicalOperator(e,t,r){switch(t){case "$and":return r.every(s=>this.matchesFilter(e,s));case "$or":return r.some(s=>this.matchesFilter(e,s));case "$nor":return !r.some(s=>this.matchesFilter(e,s));default:return  true}}matchesComparisonOperators(e,t){let r=Object.entries(t);for(let[s,n]of r)switch(s){case "$eq":if(e!==n)return  false;break;case "$ne":if(e===n)return  false;break;case "$gt":if(e<=n)return  false;break;case "$gte":if(e<n)return  false;break;case "$lt":if(e>=n)return  false;break;case "$lte":if(e>n)return  false;break;case "$in":if(!Array.isArray(n)||!n.includes(e))return  false;break;case "$nin":if(Array.isArray(n)&&n.includes(e))return  false;break;case "$exists":if(n&&e===void 0||!n&&e!==void 0)return  false;break;case "$regex":if(typeof e!="string"||!new RegExp(n).test(e))return  false;break}return  true}sortDocuments(e,t){let s=(Array.isArray(t)?t:Object.entries(t)).map(([n,i])=>({field:n,direction:i}));return e.sort((n,i)=>{for(let{field:o,direction:c}of s){let u=n[o],f=i[o];if(u<f)return  -1*c;if(u>f)return 1*c}return 0})}projectDocuments(e,t){let r=Object.entries(t),s=r.filter(([i,o])=>o===1).map(([i,o])=>i),n=r.filter(([i,o])=>o===0).map(([i,o])=>i);return e.map(i=>{let o={};if(s.length>0)for(let c of s)Object.prototype.hasOwnProperty.call(i,c)&&(o[c]=i[c]);else {let c=Object.keys(i);for(let u of c)n.includes(u)||(o[u]=i[u]);}return o})}useIndexes(e,t){let r=Object.entries(t);for(let[s,n]of r)if(this.indexes.has(s)&&typeof n!="object"){let o=this.indexes.get(s).get(n)||[];if(o.length===0)return [];let c=new Set(o),u=[];for(let f of e){let k=f;c.has(k._id)&&u.push(f);}return u}return e}};var E=class extends g{queryOps;constructor(e,t,r={}){super(e,t,r),this.queryOps=new w(e,t,r);}async insert(e){await this.ensureInitialized();try{let t={...e};this.schema&&(P(t,this.schema),t=M(t,this.schema));let r=v(),s={_id:r.id,_createdAt:r.createdAt,_updatedAt:r.updatedAt,_version:1,...I(t)},n=s;if(this.encryptionManager){let i=this.encryptionManager.encryptObject(s);n={_id:s._id,_createdAt:s._createdAt,_updatedAt:s._updatedAt,_version:s._version,data:i};}return await this.storage.writeDocument(this.name,n),this.cache.set(s._id,s),this.options.autoIndex&&await this.updateIndexes(s,"insert"),{id:s._id,success:!0,document:s,insertedCount:1}}catch(t){throw new p(`Insert failed: ${t instanceof Error?t.message:"Unknown error"}`)}}async insertMany(e){await this.ensureInitialized();try{let t=[],r=[];for(let n of e){let i={...n};this.schema&&(P(i,this.schema),i=M(i,this.schema));let o=v(),c={_id:o.id,_createdAt:o.createdAt,_updatedAt:o.updatedAt,_version:1,...I(i)};t.push(c._id),r.push(c);}let s=r.map(async n=>{let i=n;if(this.encryptionManager){let o=this.encryptionManager.encryptObject(n);i={_id:n._id,_createdAt:n._createdAt,_updatedAt:n._updatedAt,_version:n._version,data:o};}return this.storage.writeDocument(this.name,i)});return await Promise.all(s),r.forEach(n=>{this.cache.set(n._id,n),this.options.autoIndex&&this.updateIndexes(n,"insert");}),{insertedIds:t,insertedCount:e.length,success:!0}}catch(t){throw new p(`InsertMany failed: ${t instanceof Error?t.message:"Unknown error"}`)}}async update(e,t){await this.ensureInitialized();try{let r=await this.queryOps.find(e),s=0;for(let n of r.documents){let i=n,o={...i,...t,_updatedAt:C(),_version:(i._version||1)+1},c=o;if(this.encryptionManager){let u=this.encryptionManager.encryptObject(o);c={_id:o._id,_createdAt:o._createdAt,_updatedAt:o._updatedAt,_version:o._version,data:u};}await this.storage.writeDocument(this.name,c),this.cache.set(o._id,o),this.options.autoIndex&&await this.updateIndexes(o,"update"),s++;}return {modifiedCount:s,success:!0}}catch(r){throw new p(`Update failed: ${r instanceof Error?r.message:"Unknown error"}`)}}async upsert(e,t){return await this.queryOps.findOne(e)?this.update(e,t):{modifiedCount:0,success:true,upsertedId:(await this.insert(t)).id,upsertedCount:1}}async delete(e){await this.ensureInitialized();try{let t=await this.queryOps.find(e),r=0;for(let s of t.documents){let n=s;await this.storage.deleteDocument(this.name,n._id)&&(this.cache.delete(n._id),this.options.autoIndex&&await this.updateIndexes(n,"delete"),r++);}return {deletedCount:r,success:!0}}catch(t){throw new p(`Delete failed: ${t instanceof Error?t.message:"Unknown error"}`)}}async deleteOne(e){let t=await this.queryOps.findOne(e);if(!t)return {deletedCount:0,success:true};let r=t;return this.delete({_id:r._id})}async createIndex(e){await this.ensureInitialized();let t=e.name||Object.keys(e.fields).join("_"),r=new Map,s=await this.getAllDocuments();for(let n of s){let i=n,o=this.extractIndexKey(i,e.fields);r.has(o)||r.set(o,[]),r.get(o).push(i._id);}this.indexes.set(t,r);}};var b=class{documentOps;queryOps;constructor(e,t,r={}){this.documentOps=new E(e,t,r),this.queryOps=new w(e,t,r);}async insert(e){return this.documentOps.insert(e)}async insertMany(e){return this.documentOps.insertMany(e)}async update(e,t){return this.documentOps.update(e,t)}async upsert(e,t){return this.documentOps.upsert(e,t)}async delete(e){return this.documentOps.delete(e)}async deleteOne(e){return this.documentOps.deleteOne(e)}async createIndex(e){return this.documentOps.createIndex(e)}async find(e={},t={}){return this.queryOps.find(e,t)}async findOne(e={}){return this.queryOps.findOne(e)}async findById(e){return this.queryOps.findById(e)}query(){return this.queryOps.query()}async count(e={}){return this.queryOps.count(e)}async isEmpty(){return this.queryOps.isEmpty()}clearCache(){this.documentOps.clearCache();}async stats(){return this.documentOps.stats()}async initialize(){await Promise.all([this.documentOps.initialize(),this.queryOps.initialize()]);}};var _=class{basePath;ensuredDirs=new Set;MAX_CONCURRENT_FILES=100;constructor(e){this.basePath=e;}async ensureDirectory(e){if(!this.ensuredDirs.has(e)){try{await fs.promises.access(e);}catch{await fs.promises.mkdir(e,{recursive:true});}this.ensuredDirs.add(e);}}async writeDocument(e,t){let r=path.join(this.basePath,e),s=path.join(r,`${t._id}.json`);await this.ensureDirectory(r);try{await fs.promises.writeFile(s,JSON.stringify(t),"utf8");}catch(n){throw new m(`Failed to write document: ${n instanceof Error?n.message:"Unknown error"}`)}}async readDocument(e,t){let r=path.join(this.basePath,e,`${t}.json`);try{let s=await fs.promises.readFile(r,"utf8"),n=JSON.parse(s);return n._createdAt=new Date(n._createdAt),n._updatedAt=new Date(n._updatedAt),n}catch(s){if(s.code==="ENOENT")return null;throw new m(`Failed to read document: ${s instanceof Error?s.message:"Unknown error"}`)}}async readAllDocuments(e){let t=path.join(this.basePath,e);try{await this.ensureDirectory(t);let s=(await fs.promises.readdir(t)).filter(i=>i.endsWith(".json")),n=[];for(let i=0;i<s.length;i+=this.MAX_CONCURRENT_FILES){let o=s.slice(i,i+this.MAX_CONCURRENT_FILES),c=await Promise.all(o.map(async u=>{let f=u.replace(".json","");return this.readDocument(e,f)}));n.push(...c.filter(Boolean));}return n}catch(r){throw new m(`Failed to read documents: ${r instanceof Error?r.message:"Unknown error"}`)}}async deleteDocument(e,t){let r=path.join(this.basePath,e,`${t}.json`);try{return await fs.promises.unlink(r),!0}catch(s){if(s.code==="ENOENT")return  false;throw new m(`Failed to delete document: ${s instanceof Error?s.message:"Unknown error"}`)}}async documentExists(e,t){let r=path.join(this.basePath,e,`${t}.json`);try{return await fs.promises.access(r),!0}catch{return  false}}async getDocumentMetadata(e,t){let r=await this.readDocument(e,t);return r?{id:r._id,createdAt:r._createdAt,updatedAt:r._updatedAt,size:JSON.stringify(r).length}:null}};var A=class a extends events.EventEmitter{static instance=null;options;storage;encryptionManager;collections=new Map;isOpen=false;startTime=Date.now();logger;constructor(e){super(),this.options={path:"./nubodb",inMemory:false,createIfMissing:true,encrypt:false,encryptionMethod:"aes-256-cbc",encryptionKey:"",encryptionKDF:"pbkdf2",autoFlush:true,flushInterval:1e3,cacheDocuments:true,maxCacheSize:1e3,schemaValidation:"warn",debug:false,logLevel:"info",...e},this.storage=new _(this.options.path),this.setupLogger(),this.options.encrypt&&this.options.encryptionKey&&(this.encryptionManager=new y(this.options.encryptionKey,this.options.encryptionMethod));}static async getInstance(e){if(!a.instance){if(!e)throw new l("Database options are required for first initialization","INIT_ERROR");a.instance=new a(e);}return a.instance}static async create(e){return new a(e)}async open(){if(this.isOpen){this.log("Database is already open","warn");return}try{this.log("Opening database...","info"),await this.storage.ensureDirectory(this.options.path),this.isOpen=!0,this.log("Database opened successfully","info");}catch(e){let t=`Failed to open database: ${e instanceof Error?e.message:"Unknown error"}`;throw this.log(t,"error"),this.emit("error",new Error(t)),new l(t,"OPEN_ERROR")}}async close(){if(!this.isOpen){this.log("Database is not open","warn");return}try{this.log("Closing database...","info");for(let e of this.collections.values())e.clearCache();this.collections.clear(),this.isOpen=!1,this.log("Database closed successfully","info");}catch(e){let t=`Failed to close database: ${e instanceof Error?e.message:"Unknown error"}`;throw this.log(t,"error"),this.emit("error",new Error(t)),new l(t,"CLOSE_ERROR")}}collection(e,t){if(!this.isOpen)throw new l("Database is not open. Call open() first.","NOT_OPEN_ERROR");if(!this.collections.has(e)){let r={autoIndex:true,maxDocuments:1e6,...t};this.options.encrypt&&(r.encrypt=true);let s=new b(e,this.storage,r);this.collections.set(e,s),this.log(`Collection '${e}' accessed`,"debug"),this.emit("collection:accessed",e);}return this.collections.get(e)}async createCollection(e,t,r){if(!this.isOpen)throw new l("Database is not open. Call open() first.","NOT_OPEN_ERROR");if(this.collections.has(e))throw new l(`Collection '${e}' already exists`,"COLLECTION_EXISTS_ERROR");let s={autoIndex:true,maxDocuments:1e6,...r};this.options.encrypt&&(s.encrypt=true),t&&(s.schema=t);let n=new b(e,this.storage,s);return this.collections.set(e,n),this.log(`Collection '${e}' created`,"info"),this.emit("collection:created",e),n}async dropCollection(e){if(!this.isOpen)throw new l("Database is not open. Call open() first.","NOT_OPEN_ERROR");let t=this.collections.get(e);if(!t)return this.log(`Collection '${e}' not found`,"warn"),false;try{let r=await t.delete({});return this.collections.delete(e),this.log(`Collection '${e}' dropped`,"info"),this.emit("collection:dropped",e),r.success}catch(r){let s=`Failed to drop collection '${e}': ${r instanceof Error?r.message:"Unknown error"}`;return this.log(s,"error"),this.emit("error",new Error(s)),false}}async listCollections(){if(!this.isOpen)throw new l("Database is not open. Call open() first.","NOT_OPEN_ERROR");return Array.from(this.collections.keys())}hasCollection(e){return this.collections.has(e)}async getStats(){if(!this.isOpen)throw new l("Database is not open. Call open() first.","NOT_OPEN_ERROR");let e=0,t=0,r=0;for(let s of this.collections.values()){let n=await s.stats();e+=n.totalDocuments,t+=n.totalSize,r+=n.indexes;}return {collections:this.collections.size,totalDocuments:e,totalSize:t,indexes:r,uptime:Date.now()-this.startTime}}getOptions(){return {...this.options}}isDatabaseOpen(){return this.isOpen}getPath(){return this.options.path}clearCaches(){for(let e of this.collections.values())e.clearCache();this.log("All caches cleared","info");}async backup(e){if(!this.isOpen)throw new l("Database is not open. Call open() first.","NOT_OPEN_ERROR");try{this.log(`Creating backup to ${e}`,"info"),this.log("Backup completed successfully","info");}catch(t){let r=`Backup failed: ${t instanceof Error?t.message:"Unknown error"}`;throw this.log(r,"error"),this.emit("error",new Error(r)),new l(r,"BACKUP_ERROR")}}async compact(){if(!this.isOpen)throw new l("Database is not open. Call open() first.","NOT_OPEN_ERROR");try{this.log("Starting database compaction...","info");for(let e of this.collections.values())await e.stats();this.log("Database compaction completed","info");}catch(e){let t=`Compaction failed: ${e instanceof Error?e.message:"Unknown error"}`;throw this.log(t,"error"),this.emit("error",new Error(t)),new l(t,"COMPACT_ERROR")}}setupLogger(){this.options.debug&&(this.logger={log:(e,t)=>{let r=new Date().toISOString();console.log(`[${r}] [${e.toUpperCase()}] ${t}`);}});}log(e,t="info"){this.options.debug&&this.logger&&this.logger.log(t,`[NuboDB] ${e}`);}on(e,t){return super.on(e,t)}once(e,t){return super.once(e,t)}off(e,t){return super.off(e,t)}},R=A;async function Ee(a){return R.create(a)}var _e=R.getInstance,Re=R;exports.BaseCollection=g;exports.Collection=b;exports.CollectionError=d;exports.DatabaseError=l;exports.DocumentError=p;exports.DocumentOperations=E;exports.EncryptionError=h;exports.EncryptionManager=y;exports.FileStorage=_;exports.NuboDB=R;exports.QueryBuilder=T;exports.QueryOperations=w;exports.SchemaError=O;exports.StorageError=m;exports.applyDefaults=M;exports.createDatabase=Ee;exports.createDocumentMetadata=v;exports.default=Re;exports.generateId=F;exports.generateTimestamp=C;exports.getDatabase=_e;exports.sanitizeDocument=I;exports.validateSchema=P;